///////////////////////////////////////////////////////////
//  SystemFactory.h
//  Implementation of the Class SystemFactory
//  Created on:      29-1-2011 20:58:18
//  Original author: Ueno
///////////////////////////////////////////////////////////

#if !defined(EA_F5DFC6B5_65F7_49a0_895A_A86DDB25ACCF__INCLUDED_)
#define EA_F5DFC6B5_65F7_49a0_895A_A86DDB25ACCF__INCLUDED_

#include  "EE_LIB/HAL/IO/IOPin.h"

namespace APPLI
{
		/**
		 * @author Ueno
		 * @version 1.0
		 * @created 29-1-2011 20:58:19
		 */
		class SystemFactory
		{

		public:
			SystemFactory();
			virtual ~SystemFactory();

			void startup();
			
			void init();
			void clear();
			void locate(unsigned char x,unsigned char y);
			void writeChar(unsigned char c);
			void writeStr(unsigned char x,unsigned char y,char *s);
		private:
			EE_LIB::HAL::IO::IOPin m_reset;
			EE_LIB::HAL::IO::IOPin m_ce;
			EE_LIB::HAL::IO::IOPin m_dc;
			EE_LIB::HAL::IO::IOPin m_din;
			EE_LIB::HAL::IO::IOPin m_clk;
			
			void writeByte(unsigned char dat, unsigned char command);
			void wait();
			void wait1us();
			
			static const unsigned char m_font6x8[][6];
		};

}
#endif // !defined(EA_F5DFC6B5_65F7_49a0_895A_A86DDB25ACCF__INCLUDED_)
